// THIS FILE IS AUTO-GENERATED FROM navigator.js
// DO NOT EDIT.

package ui

import "time"

import "perkeep.org/pkg/fileembed"

func init() {
	Files.Add("navigator.js", 5168, time.Unix(0, 1526085226536968992), fileembed.String(fileembed.JoinStrings("/*\n"+
		"Copyright 2014 The Perkeep Authors\n"+
		"\n"+
		"Licensed under the Apache License, Version 2.0 (the \"License\");\n"+
		"you may not use this file except in compliance with the License.\n"+
		"You may obtain a copy of the License at\n"+
		"\n"+
		"	http://www.apache.org/licenses/LICENSE-2.0\n"+
		"\n"+
		"Unless required by applicable law or agreed to in writing, software\n"+
		"distributed under the License is distributed on an \"AS IS\" BASIS,\n"+
		"WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n"+
		"See the License for the specific language governing permissions and\n"+
		"limitations under the License.\n"+
		"*/\n"+
		"\n"+
		"goog.provide('cam.Navigator');\n"+
		"\n"+
		"goog.require('cam.object');\n"+
		"goog.require('goog.Uri');\n"+
		"\n"+
		"// Navigator intercepts various types of browser navigations and gives its client"+
		" an opportunity to decide whether the navigation should be handled with JavaScrip"+
		"t or not.\n"+
		"// Currently, 'click' events on hyperlinks and 'popstate' events are intercepted."+
		" Clients can also call navigate() to manually initiate navigation.\n"+
		"//\n"+
		"// @param Window win The window to listen for click and popstate events within to"+
		" potentially interpret as navigations.\n"+
		"// @param Location location Network navigation will be executed using this locati"+
		"on object.\n"+
		"// @param History history PushState navigation will be executed using this histor"+
		"y object.\n"+
		"cam.Navigator = function(win, location, history) {\n"+
		"	this.win_ = win;\n"+
		"	this.location_ = location;\n"+
		"	this.history_ = history;\n"+
		"	this.handlers_ = [];\n"+
		"\n"+
		"	// This is needed so that in handlePopState_, we can differentiate navigating ba"+
		"ck to this frame from the initial load.\n"+
		"	// We can't just initialize to {} because there can already be interesting state"+
		" (e.g., in the case of the user pressing the refresh button).\n"+
		"	history.replaceState(cam.object.extend(history.state), '', location.href);\n"+
		"\n"+
		"	this.win_.addEventListener('click', this.handleClick_.bind(this));\n"+
		"	this.win_.addEventListener('popstate', this.handlePopState_.bind(this));\n"+
		"};\n"+
		"\n"+
		"cam.Navigator.shouldHandleClick = function(e) {\n",
		"	// We are conservative and only try to handle left clicks that are unmodified.\n"+
			"	// For any other kind of click, assume that something fancy (e.g., context menu,"+
			" open in new tab, etc) is about to happen and let whatever it happen as normal.\n"+
			"	if (e.button != 0 || e.altKey || e.ctrlKey || e.metaKey || e.shiftKey) {\n"+
			"		return null;\n"+
			"	}\n"+
			"\n"+
			"	for (var elm = e.target; ; elm = elm.parentElement) {\n"+
			"		if (!elm) {\n"+
			"			return null;\n"+
			"		}\n"+
			"		if (elm.nodeName == 'A' && elm.href) {\n"+
			"			return elm;\n"+
			"		}\n"+
			"	}\n"+
			"\n"+
			"	throw new Error('Should never get here');\n"+
			"	return null;\n"+
			"};\n"+
			"\n"+
			"// Client should set this to handle navigation.\n"+
			"//\n"+
			"// This is called before the navigation has actually taken place: location.href w"+
			"ill refer to the old URL, not the new one. Also, history.state will refer to prev"+
			"ious state.\n"+
			"//\n"+
			"// If client returns true, then Navigator considers the navigation handled locall"+
			"y, and will add an entry to history using pushState(). If this method returns fal"+
			"se, Navigator lets the navigation fall through to the browser.\n"+
			"// @param goog.Uri newURL The URL to navigate to.\n"+
			"// @return boolean Whether the navigation was handled locally.\n"+
			"cam.Navigator.prototype.onWillNavigate = function(newURL) {};\n"+
			"\n"+
			"// Called after a local (pushState) navigation has been performed. At this point,"+
			" location.href and history.state have been updated.\n"+
			"cam.Navigator.prototype.onDidNavigate = function() {};\n"+
			"\n"+
			"// Programmatically initiate a navigation to a URL. Useful for triggering navigat"+
			"ions from things other than hyperlinks.\n"+
			"// @param goog.Uri url The URL to navigate to.\n"+
			"// @return boolean Whether the navigation was handled locally.\n"+
			"cam.Navigator.prototype.navigate = function(url) {\n"+
			"	if (this.dispatchImpl_(url, true)) {\n"+
			"		return true;\n"+
			"	}\n"+
			"	this.location_.href = url.toString();\n"+
			"	return false;\n"+
			"};\n"+
			"\n"+
			"// Handles navigations initiated via clicking a hyperlink.\n",
		"cam.Navigator.prototype.handleClick_ = function(e) {\n"+
			"	var elm = cam.Navigator.shouldHandleClick(e);\n"+
			"	if (!elm) {\n"+
			"		return;\n"+
			"	}\n"+
			"\n"+
			"	try {\n"+
			"		if (this.dispatchImpl_(new goog.Uri(elm.href), true)) {\n"+
			"			e.preventDefault();\n"+
			"		}\n"+
			"	} catch (ex) {\n"+
			"		// Prevent the navigation so that we can see the error.\n"+
			"		e.preventDefault();\n"+
			"		throw ex;\n"+
			"	}\n"+
			"	// Otherwise, the event continues bubbling and navigation should happen as norma"+
			"l via the browser.\n"+
			"};\n"+
			"\n"+
			"// Handles navigation via popstate.\n"+
			"cam.Navigator.prototype.handlePopState_ = function(e) {\n"+
			"	// WebKit and older Chrome versions will fire a spurious initial popstate event "+
			"after load.\n"+
			"	// We can differentiate this event from ones corresponding to frames we generate"+
			"d ourselves with pushState() or replaceState() because our own frames always have"+
			" a non-empty state.\n"+
			"	// See: http://stackoverflow.com/questions/6421769/popstate-on-pages-load-in-chr"+
			"ome\n"+
			"	if (!e.state) {\n"+
			"		return;\n"+
			"	}\n"+
			"	if (!this.dispatchImpl_(new goog.Uri(this.location_.href), false)) {\n"+
			"		this.location_.reload();\n"+
			"	}\n"+
			"};\n"+
			"\n"+
			"cam.Navigator.prototype.dispatchImpl_ = function(url, addState) {\n"+
			"	if (this.onWillNavigate(url)) {\n"+
			"		if (addState) {\n"+
			"			// Pass an empty object rather than null or undefined so that we can filter ou"+
			"t spurious initial popstate events in handlePopState_.\n"+
			"			this.history_.pushState({}, '', url.toString());\n"+
			"		}\n"+
			"		this.onDidNavigate();\n"+
			"		return true;\n"+
			"	}\n"+
			"	return false;\n"+
			"};\n"+
			"")))
}
